--
-- DoorOpener
--
-- written by fruktor, visit: www.eifok-team.de
-- Edit by }I{EKA special for MTZ-1025

DoorOpener = {};

DoorOpener.modDir = g_currentModDirectory;

function DoorOpener.prerequisitesPresent(specializations)
    return true; 
end;

function DoorOpener:load(savegame)
--  back door
	self.playerCallbackBackDoor = SpecializationUtil.callSpecializationsFunction("playerCallbackBackDoor"); 
	
	self.doorO = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.backDoorOpener#trigger")) );
	if trigger == nil then
		print("[Error::BackDoorOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.backDoorOpener#icIndex", i));
	
	self.doorO.icIndex = icIndex;
	self.doorO.trigger = trigger;
	self.doorO.plIR = false;
	
	addTrigger( trigger, "playerCallbackBackDoor", self );
	
--  reshetka
	self.playerCallbackReshetka = SpecializationUtil.callSpecializationsFunction("playerCallbackReshetka"); 
	
	self.door1 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.reshetkaOpener#trigger")) );
	if trigger == nil then
		print("[Error::ReshetkaOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.reshetkaOpener#icIndex", i));
	
	self.door1.icIndex = icIndex;
	self.door1.trigger = trigger;
	self.door1.plIR = false;
		
	addTrigger( trigger, "playerCallbackReshetka", self );
	
	--  shitoks
	self.playerCallbackShitoks = SpecializationUtil.callSpecializationsFunction("playerCallbackShitoks"); 
	
	self.door2 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.shitoksOpener#trigger")) );
	if trigger == nil then
		print("[Error::ShitoksOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.shitoksOpener#icIndex", i));
	
	self.door2.icIndex = icIndex;
	self.door2.trigger = trigger;
	self.door2.plIR = false;
	
	addTrigger( trigger, "playerCallbackShitoks", self );
	
	--  shitokss
	self.playerCallbackShitokss = SpecializationUtil.callSpecializationsFunction("playerCallbackShitokss"); 
	
	self.door3 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.shitokssOpener#trigger")) );
	if trigger == nil then
		print("[Error::ShitokssOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.shitokssOpener#icIndex", i));
	
	self.door3.icIndex = icIndex;
	self.door3.trigger = trigger;
	self.door3.plIR = false;
	
	addTrigger( trigger, "playerCallbackShitokss", self );
end;

function DoorOpener:delete()
-- back door
	if self.doorO.trigger ~= nil then
		removeTrigger(self.doorO.trigger);
	end;
--  reshetka
	if self.door1.trigger ~= nil then
		removeTrigger(self.door1.trigger);
	end;
	--  shitoks
	if self.door2.trigger ~= nil then
		removeTrigger(self.door2.trigger);
	end;
	--  shitokss
	if self.door3.trigger ~= nil then
		removeTrigger(self.door3.trigger);
	end;
end;

function DoorOpener:readStream(streamId, connection)
end;

function DoorOpener:writeStream(streamId, connection)
end;

function DoorOpener:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DoorOpener:keyEvent(unicode, sym, modifier, isDown)
end;

function DoorOpener:update(dt)
	if self.doorO.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_BACKDOOROPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_BACKDOOROPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.doorO.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.doorO.icIndex);
			end;
		end
	end;
	if self.door1.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_RESHETKAOPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_RESHETKAOPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.door1.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door1.icIndex);
			end;
		end
	end;
	if self.door2.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_SHITOKSOPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_SHITOKSOPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.door2.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door2.icIndex);
			end;
		end
	end;
	if self.door3.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_SHITOKSSOPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_SHITOKSSOPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.door3.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door3.icIndex);
			end;
		end
	end;
end;

function DoorOpener:onLeave()
end;

function DoorOpener:draw()
end;

function DoorOpener:playerCallbackBackDoor(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorO.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorO.plIR = false;
	end;
end;

function DoorOpener:playerCallbackReshetka(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door1.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door1.plIR = false;
	end;
	
	function DoorOpener:playerCallbackShitoks(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door2.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door2.plIR = false;
	end;
	
	function DoorOpener:playerCallbackShitokss(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door3.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door3.plIR = false;
	end;
end;
